package com.diagbot.facade;


import com.diagbot.dto.SaveInquiryTriageDTO;
import com.diagbot.entity.InquiryTriage;
import com.diagbot.service.impl.InquiryTriageServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.DateUtil;
import com.diagbot.util.GsonUtil;
import com.diagbot.util.HttpUtils;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.HospitalVO;
import com.diagbot.vo.SaveInquiryTriageVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

/**
 * @Description:
 * @author: wangfeng
 * @time: 2020/3/23 10:33
 */
@Component
public class InquiryTriageFacade extends InquiryTriageServiceImpl {

    @Autowired
    OptInfoFacade optInfoFacade;

    /**
     * @param saveInquiryVO
     * @return
     */
    public SaveInquiryTriageDTO saveInquiry(SaveInquiryTriageVO saveInquiryVO) {
        if (StringUtil.isBlank(saveInquiryVO.getHospitalCode())) {
            saveInquiryVO.setHospitalCode("朗通通用");
        }
        Date now = DateUtil.now();
        InquiryTriage inquiryInfo = new InquiryTriage();
        BeanUtil.copyProperties(saveInquiryVO, inquiryInfo);
        inquiryInfo.setGmtCreate(now);
        inquiryInfo.setGmtModified(now);
        inquiryInfo.setDisDept(GsonUtil.toJson(saveInquiryVO.getDisDeptist()));
        inquiryInfo.setIp(HttpUtils.getIpAddress());
        boolean res = save(inquiryInfo);

        HospitalVO hospitalVO = new HospitalVO();
        hospitalVO.setHospitalCode(saveInquiryVO.getHospitalCode());
        hospitalVO.setSysType(saveInquiryVO.getSysType());
        // 保存记录表
        optInfoFacade.saveOptOnfo(hospitalVO, "2");
        //邵逸夫医院 心理测试 对接纳里时，返回url
        SaveInquiryTriageDTO saveInquiryDTO = new SaveInquiryTriageDTO();

/*        if (saveInquiryVO.getHospitalCode().equals("邵逸夫医院")
                && saveInquiryVO.getIdType().equals(1)) {
            List<String> naliRetList = getUrl(saveInquiryVO);
            String retUrl = naliRetList.get(0);
            saveInquiryDTO.setBody(retUrl);
            saveInquiryDTO.setResponse(naliRetList.get(1));
            saveInquiryDTO.setRequest(naliRetList.get(2));
            saveInquiryDTO.setRequestBodys(naliRetList.get(3));
        }*/
        return saveInquiryDTO;
    }

    private List<String> getUrl(SaveInquiryTriageVO saveInquiryVO) {
        //TODO 待定
        /*List<String> ret = Lists.newArrayList();
        String retUrl = null;
        Request request = null;
        Response response = null;
        try {
            String encodingAesKey = "";
            Client client = new Client(apiUrl, appKey, appSecret, encodingAesKey);
            request = getltcs(saveInquiryVO);
            response = client.execute(request);
            log.info("request:" + FastJsonUtils.getBeanToJson(request));
            log.info("requestBodys:" + FastJsonUtils.getBeanToJson(request.getBodys()));
            log.info("response：" + FastJsonUtils.getBeanToJson(response));
            if (response.isSuccess()) {
                JSONResponseBean result = response.getJsonResponseBean();
                retUrl = result.getBody().toString();
            }
        } catch (Exception e) {
        }
        ret.add(retUrl);
        ret.add(FastJsonUtils.getBeanToJson(response));
        ret.add(FastJsonUtils.getBeanToJson(request));
        ret.add(FastJsonUtils.getBeanToJson(request.getBodys()));*/
        return null;
    }
}